require 'spec_helper'

describe SomeDefaultBarbell do

  subject { described_class.new(params) }

  describe '#perform' do
    let(:trainer) { DeadliftHelpers::PerformanceSpy.new }

    context 'valid params' do
      let(:params) { { some_value: 1 } }

      specify {
        subject.add_trainer(trainer).perform
        expect(trainer.deadlift).to eq :some_default_barbell
        expect(trainer.state).to eq :success
        expect(trainer.performance.result.some_value).to eq params[:some_value]
      }
    end

    context 'invalid params' do
      let(:params) { { some_value: 2 } }

      specify {
        subject.add_trainer(trainer).perform
        expect(trainer.deadlift).to eq :some_default_barbell
        expect(trainer.state).to eq :failure
        expect(trainer.performance.barbell.errors.count).to eq 1
      }
    end
  end
end

# The other when using proper barbell and deadlift validations
describe SomeDeadlift do

  subject { described_class.new(params) }

  describe '#perform' do
    let(:trainer) { DeadliftHelpers::PerformanceSpy.new }

    context 'valid params' do
      let(:params) { { id: 1 } }
      specify {
        expect { subject.add_trainer(trainer).perform}.to raise_error(SomeDeadlift::SomeDeadliftError)
      }
    end

    context 'invalid params' do
      let(:params) { { id: nil } }

      specify {
        subject.add_trainer(trainer).perform
        expect(trainer.deadlift).to eq :some_deadlift
        expect(trainer.state).to eq :failure
      }
    end
  end
end
